Components.utils.import('resource://gre/modules/XPCOMUtils.jsm');

/* ------------------------------------------------------------------------ */

XPCOMUtils.defineLazyServiceGetter(window, 'windowMediator', '@mozilla.org/appshell/window-mediator;1', 'nsIWindowMediator');
XPCOMUtils.defineLazyServiceGetter(window, 'observerService', '@mozilla.org/observer-service;1', 'nsIObserverService');

/* ------------------------------------------------------------------------ */

var mainObserver = {
	observe: function (subject, topic, data) {
		if (topic == 'xul-window-destroyed') {
			let enumerator = windowMediator.getXULWindowEnumerator(null);
			let counter = 0;
			
			while (enumerator.hasMoreElements()) {
				enumerator.getNext();
				
				counter += 1;
			}
			
			if (counter <= 2) {
				close();
			}
		}
	}
};

/* ------------------------------------------------------------------------ */

function handleDOMContentLoadedEvent(event) {
	if (event.target != document) {
		return;
	}
	
	observerService.addObserver(mainObserver, 'xul-window-destroyed', false);
}

addEventListener('DOMContentLoaded', handleDOMContentLoadedEvent, false);

function handleUnloadEvent(event) {
	if (event.target != document) {
		return;
	}
	
	observerService.removeObserver(mainObserver, 'xul-window-destroyed');
}

addEventListener('unload', handleUnloadEvent, false);
